import Qt 4.7
import "UIConstants.js" as UI

Rectangle {
    id: root
    color: "#00000000"

    property alias iconSource: icon.source
    property bool repeat: true

    signal clicked

    Image {
        id: icon
        smooth: true
        fillMode: Image.Stretch
        anchors.centerIn: parent
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent
        onClicked: root.clicked()
        onPressAndHold: { if (root.repeat && timer.running == false) timer.start() }
        onReleased: { if (root.repeat && timer.running) timer.stop() }
    }

    Timer {
        id: timer
        running: false
        repeat: true
        onTriggered: root.clicked()
    }

    states: State {
        name: "pressed"
        when: mouseArea.pressed
        PropertyChanges {
            target: icon
            width: UI.REMOTE_BUTTON_PRESSED_SIZE * root.width
            height: UI.REMOTE_BUTTON_PRESSED_SIZE * root.height
            opacity: UI.REMOTE_BUTTON_PRESSED_OPACITY
        }
    }

    onWidthChanged: icon.width = width
    onHeightChanged: icon.height = height
}
